//Source file: ServiceInteraction.java
//Date: October 2006
//Service Broker Interfaces and Data Types for 3GPP TS 29.198-16 V2.0.0 Release 7

package org.csapi.jr.se.svcbroker;

/**
 * This interface represents a ServiceInteraction activity object.<BR>
 *
 */
public interface ServiceInteraction extends org.csapi.jr.se.Activity {

    /**
     * Returns a reference to the ServiceBroker responsible for creation of the ServiceInteraction.
     *
     * @return  A reference to the ServiceBroker responsible for creation of the ServiceInteraction.
     */
    org.csapi.jr.se.svcbroker.ServiceBroker getServiceBroker();


    /**
     * Invokes the registerServiceInteraction() method on the Parlay Gateway.
     */
    void registerServiceInteraction(
           java.lang.String                clientBrokerID,
           org.csapi.jr.se.svcbroker.EndpointAddress endpointAddress,
           org.csapi.jr.se.svcbroker.ServiceKey serviceKey)
      throws org.csapi.jr.se.PlatformException,
       java.lang.IllegalStateException,
       org.csapi.jr.se.CommonException,
       org.csapi.jr.se.svcbroker.InvalidServiceInteractionException,
       org.csapi.jr.se.InvalidCriteriaException;

    /**
     * Invokes the unregisterServiceInteraction() method on the Parlay Gateway.
     */
    void unregisterServiceInteraction()
      throws org.csapi.jr.se.PlatformException,
       java.lang.IllegalStateException,
       org.csapi.jr.se.CommonException;
}
