//Source file: ServiceKey.java
//Date: October 2006
//Service Broker Interfaces and Data Types for 3GPP TS 29.198-16 V2.0.0 Release 7

package org.csapi.jr.se.svcbroker;

/**
 * 
 *
 */
public final class ServiceKey implements java.io.Serializable {

    private ServiceKeyType _discriminator = null;
    private java.lang.Object _object;

    /**
     * Creates a new ServiceKey.
     * Tagged choice of data elements always have empty constructors
     */ 
    public ServiceKey() {}

    /**
     * This method returns the discriminator.
     * 
     * @return a ServiceKeyType value 
     * @exception InvalidUnionAccessorException if an error occurs 
     */ 
    public ServiceKeyType getDiscriminator() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator == null) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return _discriminator;
    }

    /**
     * This method returns a ServiceKeyValue
     * 
     * @return  a int value
     * @exception InvalidUnionAccessorException if an error occurs 
     */
    public int getServiceKeyValue() throws org.csapi.jr.se.InvalidUnionAccessorException {
        if (_discriminator != ServiceKeyType.SERVICE_KEY) {
            throw new org.csapi.jr.se.InvalidUnionAccessorException();
        }
        return (((java.lang.Integer) _object).intValue());
    }

    /**
     * This method sets a ServiceKeyValue
     * 
     * @param value a int value
     */
    public void setServiceKeyValue(int value) {
        _discriminator = ServiceKeyType.SERVICE_KEY;
        _object = new java.lang.Integer(value);
    }


    /**
     * This method will receive the discriminator as a parameter and will set _object to null
     * 
     * @param discriminator a ServiceKeyType value 
     */ 
    public void setUndefined(ServiceKeyType discriminator) {
        _discriminator = discriminator;
        _object = null;
    }

    /**
     * Indicates whether some other object is 'equal to' this one.
     */
    public boolean equals(Object o) {
        if (o == null) {
            return false;
        }
        if(!(o instanceof ServiceKey)) {
            return false;
        } else {
            ServiceKey serviceKey= (ServiceKey)o;
            if(!(this._object.equals(serviceKey._object))){
                return false;
            } else {
                if(!(this._discriminator.equals(serviceKey._discriminator))){
                    return false;
                }
            }
            if (this.hashCode() != o.hashCode()) {
                return false;
            }
            return true;
        }
    }

    /**
     * Returns a hashcode value for the object.
     */
    public int hashCode() {
        return 1;
    }

} // ServiceKey

